//
// PODSteam - Loader for Old CS Bots
// Copyright (c) 2005, by Wei Mingzhi
// Copyright (c) 2006, by Dmitry Zhukov
//

// FIXME: Only one bug! Only one bot never wants to join team!

#include "podsteam.h"

float g_rgflPrevSpeed[32];
int g_rgiMenuState[32];

bool g_bIsFakeClientCommand = FALSE;
char *g_szCommand = NULL;

edict_t *g_pentShowMenuTarget = NULL;
edict_t *g_pentWeaponListTarget = NULL;
dynlib_t g_hBotLib = NULL;
dynlib_t g_hGameLib = NULL;
dynlib_t g_hSelfLib = NULL;

enginefuncs_t g_engfuncs;
enginefuncs_t *g_bot_engfuncs = NULL;
globalvars_t *gpGlobals;
DLL_FUNCTIONS other_gFunctionTable, gFunctionTable;

GETENTITYAPI other_GetEntityAPI = NULL;
GIVEFNPTRSTODLL other_GiveFnptrsToDll = NULL;

CBotAim g_kBotAim;
CPodFix g_kPodFix;

bool g_bHLTVReceived = false;
bool g_bPODIngame = false;

int message_HLTV;
int message_WeaponList;
int message_ShowMenu;

int g_iMsecVal = 0;
int g_iMsgState = 0;

cvar_t cvarModMsec = {"pstm_modifymsec", "1", FCVAR_EXTDLL, 1.0};
cvar_t cvarModVersion = {"pstm_version", "2.0", FCVAR_EXTDLL, 2.0};

void (*pfnMessageCatch) (edict_t *, void *) = NULL;

// fixing problems with the team selection
std::vector <tShowMenu> g_kPendingMessages;
float g_fMenuUpdateTime = 0.0;


typedef struct
{
   char szClassname[64];
   int iAmmo1; // ammo index for primary ammo
   int iAmmo1Max; // max primary ammo
   int iAmmo2; // ammo index for secondary ammo
   int iAmmo2Max; // max secondary ammo
   int iSlot; // HUD slot (0 based)
   int iPosition; // slot position
   int iId; // weapon ID
   int iFlags; // flags???
} bot_weapon_t;

bot_weapon_t weapon_defs[32] =
{
   // szClassname          iAmmo1   iAmmo1Max   iAmmo2   iAmmo2Max   iSlot iPosition   iId   iFlags
   {"",                    0,       0,          0,       0,          0,    0,          0,    0},
   {"weapon_p228",         9,       52,         0,       0,          1,    3,          1,    0},
   {"",                    0,       0,          0,       0,          0,    0,          2,    0},
   {"weapon_scout",        2,       90,         0,       0,          0,    9,          3,    0},
   {"weapon_hegrenade",    12,      1,          0,       0,          3,    1,          4,    0},
   {"weapon_xm1014",       5,       32,         0,       0,          0,    12,         5,    0},
   {"weapon_c4",           14,      1,          0,       0,          4,    3,          6,    0},
   {"weapon_mac10",        6,       100,        0,       0,          0,    13,         7,    0},
   {"weapon_aug",          4,       90,         0,       0,          0,    14,         8,    0},
   {"weapon_smokegrenade", 13,      1,          0,       0,          3,    3,          9,    0},
   {"weapon_elite",        10,      120,        0,       0,          1,    5,          10,   0},
   {"weapon_fiveseven",    7,       100,        0,       0,          1,    6,          11,   0},
   {"weapon_ump45",        6,       100,        0,       0,          0,    15,         12,   0},
   {"weapon_sg550",        4,       90,         0,       0,          0,    16,         13,   0},
   {"weapon_galil",        4,       90,         0,       0,          0,    0,          14,   0},
   {"weapon_famas",        4,       90,         0,       0,          0,    0,          15,   0},
   {"weapon_usp",          6,       100,        0,       0,          1,    4,          16,   0},
   {"weapon_glock18",      10,      120,        0,       0,          1,    2,          17,   0},
   {"weapon_awp",          1,       30,         0,       0,          0,    2,          18,   0},
   {"weapon_mp5navy",      10,      120,        0,       0,          0,    7,          19,   0},
   {"weapon_m249",         3,       200,        0,       0,          0,    4,          20,   0},
   {"weapon_m3",           5,       32,         0,       0,          0,    5,          21,   0},
   {"weapon_m4a1",         4,       90,         0,       0,          0,    6,          22,   0},
   {"weapon_tmp",          10,      120,        0,       0,          0,    11,         23,   0},
   {"weapon_g3sg1",        2,       90,         0,       0,          0,    3,          24,   0},
   {"weapon_flashbang",    11,      2,          0,       0,          3,    2,          25,   0},
   {"weapon_deagle",       8,       35,         0,       0,          1,    1,          26,   0},
   {"weapon_sg552",        4,       90,         0,       0,          0,    10,         27,   0},
   {"weapon_ak47",         2,       90,         0,       0,          0,    1,          28,   0},
   {"weapon_knife",        -1,      -1,         0,       0,          2,    1,          29,   0},
   {"weapon_p90",          7,       100,        0,       0,          0,    8,          30,   0},
   {"",                    0,       0,          0,       0,          0,    0,          31,   0},
};

void SendValidMessage (tShowMenu *pMenu)
{
   // this function translating "new" cs 1.6, messsages to "old", to allow old
   // bots to join teams without a problems.

   if (FNullEnt (pMenu->pent) || (pMenu->szActualMessage[0] == 0x0))
      return;

   g_bot_engfuncs->pfnMessageBegin (MSG_ONE, message_ShowMenu, NULL, pMenu->pent);
   g_bot_engfuncs->pfnWriteShort (pMenu->iShort);
   g_bot_engfuncs->pfnWriteChar (pMenu->iChar);
   g_bot_engfuncs->pfnWriteByte (pMenu->iByte);

   if (strcmp (pMenu->szActualMessage, "#Team_Select_Spect") == 0)
      g_bot_engfuncs->pfnWriteString ("#Team_Select");
   if (strcmp (pMenu->szActualMessage, "#IG_Team_Select_Spect") == 0)
      g_bot_engfuncs->pfnWriteString ("#Team_Select");
   if (strcmp (pMenu->szActualMessage, "#IG_VIP_Team_Select") == 0)
      g_bot_engfuncs->pfnWriteString ("#Team_Select");
   if (strcmp (pMenu->szActualMessage, "#IG_VIP_Team_Select_Spect") == 0)
      g_bot_engfuncs->pfnWriteString ("#Team_Select");
   if (strcmp (pMenu->szActualMessage, "#IG_Team_Select") == 0)
      g_bot_engfuncs->pfnWriteString ("#Team_Select");

   g_bot_engfuncs->pfnMessageEnd ();
}

void NetMsg_ShowMenu (edict_t *pent, void *p)
{
   // this function gets called when ShowMenu network message is finished.

   static int iShort;
   static int iChar;
   static int iByte;

   if (g_iMsgState == 0)
      iShort = *(int *) p;
   else if (g_iMsgState == 1)
      iChar = *(int *) p;
   else if (g_iMsgState == 2)
      iByte = *(int *) p;
   else
   {
      tShowMenu kMenu; // temporaly variable to store menu
      memset (&kMenu, 0, sizeof (tShowMenu));

      // fill the structure
      kMenu.iByte = iByte;
      kMenu.iChar = iChar;
      kMenu.iShort = iShort;
      kMenu.pent = pent;

      strcpy (kMenu.szActualMessage, (char *) p);

      // and finally put message into our "Fake" queue
      g_kPendingMessages.push_back (kMenu);
   }
   g_iMsgState++; // update messages state
}

void GameDLLInit(void)
{
   CVAR_REGISTER (&cvarModMsec);
   CVAR_REGISTER (&cvarModVersion);

   g_kBotAim.RegisterCVars ();
   g_kPodFix.RegisterCVars ();

   (*g_engfuncs.pfnServerPrint) ("\n********\n Bots running on this server running under PODSteam v2.0\n");
   (*g_engfuncs.pfnServerPrint) (" Developed by Wei Mingzhi, Updated by Dmitry Zhukov.\n");
   (*g_engfuncs.pfnServerPrint) (" This program is licensed under the BSD License.\n********\n");


   (*other_gFunctionTable.pfnGameInit)();
}

void ClientDisconnect( edict_t *pEntity )
{
   int iIndex = ENTINDEX(pEntity) - 1;
   if (iIndex >= 0 && iIndex < 32)
   {
      g_rgflPrevSpeed[iIndex] = -1;
      g_rgiMenuState[iIndex] = Menu_None;
   }

   (*other_gFunctionTable.pfnClientDisconnect) (pEntity);
}

int Spawn (edict_t *pent)
{
   int iResult = (*other_gFunctionTable.pfnSpawn) (pent);
   g_kPodFix.OnSpawnPost (pent);

   return iResult;
}

void StartFrame(void)
{
   if ((g_fMenuUpdateTime < gpGlobals->time) && !g_kPendingMessages.empty ())
   {
      tShowMenu &kMenu = g_kPendingMessages.back (); // get the last message
      SendValidMessage (&kMenu); // send it...

      g_kPendingMessages.pop_back (); // ... and drop it
      g_fMenuUpdateTime = gpGlobals->time + 0.2; // update this in next 0.2 secs.
   }

   for (int i = 0; i < gpGlobals->maxClients; i++)
   {
      edict_t *pEdict = INDEXENT(i + 1);

      if (FNullEnt(pEdict))
         continue;

      if (pEdict->v.maxspeed != g_rgflPrevSpeed[i])
      {
         g_bot_engfuncs->pfnSetClientMaxspeed(pEdict, pEdict->v.maxspeed);
         g_rgflPrevSpeed[i] = pEdict->v.maxspeed;
      }
   }

   if (!FNullEnt(g_pentWeaponListTarget))
   {
      // send the weaponlist message
      for (int i = 0; i < gpGlobals->maxClients; i++)
      {
         g_bot_engfuncs->pfnMessageBegin(MSG_ONE, message_WeaponList, NULL, g_pentWeaponListTarget);
         g_bot_engfuncs->pfnWriteString(weapon_defs[i].szClassname);
         g_bot_engfuncs->pfnWriteByte(weapon_defs[i].iAmmo1);
         g_bot_engfuncs->pfnWriteByte(weapon_defs[i].iAmmo1Max);
         g_bot_engfuncs->pfnWriteByte(weapon_defs[i].iAmmo2);
         g_bot_engfuncs->pfnWriteByte(weapon_defs[i].iAmmo2Max);
         g_bot_engfuncs->pfnWriteByte(weapon_defs[i].iSlot);
         g_bot_engfuncs->pfnWriteByte(weapon_defs[i].iPosition);
         g_bot_engfuncs->pfnWriteByte(weapon_defs[i].iId);
         g_bot_engfuncs->pfnWriteByte(weapon_defs[i].iFlags);
         g_bot_engfuncs->pfnMessageEnd();
      }
      g_pentWeaponListTarget = NULL;
   }
   (*other_gFunctionTable.pfnStartFrame)();

   g_kBotAim.OnFramePost ();
   g_kPodFix.OnFramePost ();
}

void FakeClientCommand(edict_t *pEntity, const char *szCommand)
{
   if (FNullEnt(pEntity))
      return;

   g_bIsFakeClientCommand = TRUE;

   g_szCommand = (char *)szCommand;
   (*other_gFunctionTable.pfnClientCommand)(pEntity);

   g_bIsFakeClientCommand = FALSE;
}

void ClientCommand( edict_t *pEntity )
{
   if ((pEntity->v.flags & FL_FAKECLIENT) && !IsYaPB (pEntity)) // This is a bot
   {
      // intercept the client commands here to let the bots buy weapons correctly in CS 1.6
      int i = ENTINDEX(pEntity) - 1;
      if (i > 31)
      {
         (*other_gFunctionTable.pfnClientCommand)(pEntity);
         return;
      }

      const char *pcmd = g_bot_engfuncs->pfnCmd_Argv(0);
      const char *arg1 = g_bot_engfuncs->pfnCmd_Argv(1);

      if (!strcmp(pcmd, "buy"))
      {
         g_rgiMenuState[i] = Menu_Buy;
      }
      else if (!strcmp(pcmd, "buyequip"))
      {
         g_rgiMenuState[i] = Menu_BuyItem;
      }
      else if (!strcmp(pcmd, "menuselect"))
      {
         int iSelection = atoi(arg1);
         if (g_rgiMenuState[i] == Menu_Buy)
         {
            if (iSelection == 1)
               g_rgiMenuState[i] = Menu_BuyPistol;
            else if (iSelection == 2)
               g_rgiMenuState[i] = Menu_BuyShotgun;
            else if (iSelection == 3)
               g_rgiMenuState[i] = Menu_BuySubMachineGun;
            else if (iSelection == 4)
               g_rgiMenuState[i] = Menu_BuyRifle;
            else if (iSelection == 8)
               g_rgiMenuState[i] = Menu_BuyItem;
            else
            {
               FakeClientCommand(pEntity, "buy");
               (*other_gFunctionTable.pfnClientCommand)(pEntity);
            }
         }
         else if (g_rgiMenuState[i] == Menu_BuyPistol)
         {
            const char *szBuyPistolList[] =
            {
               "glock",
               "usp",
               "deagle",
               "p228",
               "elites",
               "fn57"
            };
            g_rgiMenuState[i] = Menu_None;
            if (iSelection >= 1 && iSelection <= 6)
               FakeClientCommand(pEntity, szBuyPistolList[iSelection - 1]);
         }
         else if (g_rgiMenuState[i] == Menu_BuyShotgun)
         {
            const char *szBuyShotgunList[] =
            {
               "m3",
               "xm1014"
            };
            g_rgiMenuState[i] = Menu_None;
            if (iSelection >= 1 && iSelection <= 2)
               FakeClientCommand(pEntity, szBuyShotgunList[iSelection - 1]);
         }
         else if (g_rgiMenuState[i] == Menu_BuySubMachineGun)
         {
            const char *szBuySMGList[] =
            {
               "mp5",
               "tmp",
               "p90",
               "mac10",
               "ump45"
            };
            g_rgiMenuState[i] = Menu_None;
            if (iSelection >= 1 && iSelection <= 2)
               FakeClientCommand(pEntity, szBuySMGList[iSelection - 1]);
         }
         else if (g_rgiMenuState[i] == Menu_BuyRifle)
         {
            const char *szBuyRifleList[] =
            {
               "ak47",
               "sg552",
               "m4a1",
               "aug",
               "scout",
               "awp",
               "g3sg1",
               "sg550"
            };
            g_rgiMenuState[i] = Menu_None;
            if (iSelection >= 1 && iSelection <= 8)
               FakeClientCommand(pEntity, szBuyRifleList[iSelection - 1]);
         }
         else if (g_rgiMenuState[i] == Menu_BuyItem)
         {
            if (iSelection == 6)
               FakeClientCommand(pEntity, "defuser");
            else
            {
               FakeClientCommand(pEntity, "buyequip");
               (*other_gFunctionTable.pfnClientCommand)(pEntity);
            }
         }
         else
            (*other_gFunctionTable.pfnClientCommand)(pEntity);
      }
      else
         (*other_gFunctionTable.pfnClientCommand)(pEntity);
   }
   else
      (*other_gFunctionTable.pfnClientCommand)(pEntity);
}


export int GetEntityAPI( DLL_FUNCTIONS *pFunctionTable, int interfaceVersion )
{
   if ( !pFunctionTable || interfaceVersion != INTERFACE_VERSION )
      return FALSE;

   if (!(*other_GetEntityAPI)(&other_gFunctionTable, INTERFACE_VERSION))
      return FALSE;

   memcpy( &gFunctionTable, &other_gFunctionTable, sizeof(DLL_FUNCTIONS));

   gFunctionTable.pfnGameInit = GameDLLInit;
   gFunctionTable.pfnStartFrame = StartFrame;
   gFunctionTable.pfnClientCommand = ClientCommand;
   gFunctionTable.pfnClientDisconnect = ClientDisconnect;

   memcpy( pFunctionTable, &gFunctionTable, sizeof( DLL_FUNCTIONS ) );

   return TRUE;
}

edict_t *pfnCreateFakeClient(const char *netname)
{
   edict_t *pentBot = (*g_engfuncs.pfnCreateFakeClient)(netname);

   if (!FNullEnt (pentBot))
   {
      g_pentWeaponListTarget = pentBot;

       // steamfix
      (*g_engfuncs.pfnSetClientKeyValue) (ENTINDEX (pentBot), (*g_engfuncs.pfnGetInfoKeyBuffer) (pentBot), "_vgui_menus", "0");
   }

   return pentBot;
}

void pfnRunPlayerMove (edict_t *fakeclient, const float *viewangles, float forwardmove, float sidemove, float upmove, unsigned short buttons, byte impulse, byte msec)
{
   // bots using thefatal's method for msec calculation, moving to slow on my PC (P3-933, 256RAM, 64GeForce4MX, WinXP HE), and moving
   // normal (or too fast) on my brothers PC (P4-3800, 2048RAM, 256RadeonX600, WinXP PRO), however PM's method working perfectly on both systems,
   // and my friends systems.

   if (!g_kPodFix.OnRunPlayerMove (fakeclient, viewangles, forwardmove, sidemove, upmove, buttons, impulse, g_iMsecVal))
      return;

   // if your system works perfectly with standard bot msec value, disable this shit...
   if (CVAR_GET_FLOAT ("pstm_modifymsec"))
   {
      g_iMsecVal = (int) (gpGlobals->frametime * 1000);

      if (g_iMsecVal > 255)
         g_iMsecVal = 255;

      g_engfuncs.pfnRunPlayerMove (fakeclient, viewangles, forwardmove, sidemove, upmove, buttons, impulse, g_iMsecVal);
      return;
   }

   // run real function
   g_engfuncs.pfnRunPlayerMove (fakeclient, viewangles, forwardmove, sidemove, upmove, buttons, impulse, msec);
}


void pfnMessageBegin(int msg_dest, int msg_type, const float *pOrigin, edict_t *ed)
{
   if (msg_type == message_HLTV && msg_dest == 9)
      g_bHLTVReceived = TRUE;
 
   if (!FNullEnt(ed) && (msg_type == message_ShowMenu) && (ed->v.flags & FL_FAKECLIENT) && !IsYaPB (ed))
   {
      g_pentShowMenuTarget = ed;
      pfnMessageCatch = NetMsg_ShowMenu;
   }

   (*g_engfuncs.pfnMessageBegin) (msg_dest, msg_type, pOrigin, ed);
}

void pfnMessageEnd (void)
{
   if (pfnMessageCatch != NULL)
      pfnMessageCatch = NULL;

   (*g_engfuncs.pfnMessageEnd) ();
}

int pfnRegUserMsg(const char *pszName, int iSize)
{
   int iType = g_engfuncs.pfnRegUserMsg(pszName, iSize);

   if (FStrEq(pszName, "HLTV"))
      message_HLTV = iType;
   else if (FStrEq(pszName, "WeaponList"))
      message_WeaponList = iType;
   else if (FStrEq (pszName, "ShowMenu"))
      message_ShowMenu = iType;

   return iType;
}

void pfnWriteByte(int iValue)
{
   // For POD-Bot the new round detection should be called only ONCE for each round
   static float flLastTimeHLTV = -9999;

   if (g_bHLTVReceived)
   {
      if (iValue == 0 && flLastTimeHLTV < gpGlobals->time)
      {
         g_bot_engfuncs->pfnFindEntityByString(NULL, "classname", "info_map_parameters");
         flLastTimeHLTV = gpGlobals->time + 2.0;
      }
   }
   g_bHLTVReceived = FALSE;

   if (pfnMessageCatch != NULL)
      (*pfnMessageCatch) (g_pentShowMenuTarget, (void *) &iValue);

   (*g_engfuncs.pfnWriteByte) (iValue);
}

void pfnWriteChar (int iValue)
{
   if (pfnMessageCatch != NULL)
      (*pfnMessageCatch) (g_pentShowMenuTarget, (void *) &iValue);

   (*g_engfuncs.pfnWriteChar) (iValue);
}

void pfnWriteShort (int iValue)
{
   if (pfnMessageCatch != NULL)
      (*pfnMessageCatch) (g_pentShowMenuTarget, (void *) &iValue);

   (*g_engfuncs.pfnWriteShort) (iValue);
}

void pfnWriteString (const char *sz)
{
   if (pfnMessageCatch != NULL)
      (*pfnMessageCatch) (g_pentShowMenuTarget, (void *) sz);

   (*g_engfuncs.pfnWriteString) (sz);
}

const char *pfnCmd_Args( void )
{
   if (g_bIsFakeClientCommand)
      return g_szCommand;
   else
      return (*g_engfuncs.pfnCmd_Args)();
}

const char *pfnCmd_Argv( int argc )
{
   if (g_bIsFakeClientCommand)
      return g_szCommand;
   else
      return (*g_engfuncs.pfnCmd_Argv)(argc);
}

int pfnCmd_Argc( void )
{
   if (g_bIsFakeClientCommand)
      return 1;
   else
      return (*g_engfuncs.pfnCmd_Argc)();
}

void pfnGetGameDir(char *szGetGameDir)
{
   strcpy(szGetGameDir, "./cstrike");
}

void pfnTraceLine (const float *v1, const float *v2, int fNoMonsters, edict_t *pentToSkip, TraceResult *ptr)
{
   bool bTrace1 = g_kBotAim.OnTraceLine (v1, v2, fNoMonsters, pentToSkip, ptr);
   bool bTrace2 = g_kPodFix.OnTraceLine (v1, v2, fNoMonsters, pentToSkip, ptr);
   
   if (bTrace1 || bTrace2)
      (*g_engfuncs.pfnTraceLine) (v1, v2, fNoMonsters, pentToSkip, ptr);
}

edict_t *pfnFindEntByStr (edict_t *pEdictStartSearchAfter, const char *pszField, const char *pszValue)
{
   g_kPodFix.OnFindEntByStr (pEdictStartSearchAfter, pszField, pszValue);

   return (*g_engfuncs.pfnFindEntityByString) (pEdictStartSearchAfter, pszField, pszValue);
}

DLL_GIVEFNPTRSTODLL GiveFnptrsToDll( enginefuncs_t* pengfuncsFromEngine, globalvars_t *pGlobals )
{
   memcpy(&g_engfuncs, pengfuncsFromEngine, sizeof(enginefuncs_t));
   gpGlobals = pGlobals;

   FILE *fp = fopen("cstrike/liblist.gam", "r");
   assert(fp);

   static char szBotDLLName[256];
   strcpy(szBotDLLName, "cstrike/");

   bool bBotDLLLoaded = FALSE;

   while (!feof(fp))
   {
      char szLine[256];
      fgets(szLine, 256, fp);

      if (strncmp(szLine, "botdll ", 7) == 0)
      {
         int iLength = strlen(szLine);
         int iPos = 8;
         int iStrPos;
         for (iStrPos = 7; iStrPos < iLength; iStrPos++)
         {
            // find the first "
            if (szLine[iStrPos] == '\"')
               break;
         }
         if (iStrPos >= iLength)
            continue; // this line is invalid
         iStrPos++;
         for (int i = iStrPos; i < iLength; i++)
         {
            if (szLine[i] != '\"' && szLine[i])
               szBotDLLName[iPos++] = szLine[i];
            else
               break;
         }
         szBotDLLName[iPos] = 0;
         bBotDLLLoaded = TRUE;
         break;
      }
   }

   if (!bBotDLLLoaded || !(fp = fopen (szBotDLLName, "rb"))) // use POD-Bot by default if the bot DLL name isn't specified
      strcpy (szBotDLLName, "cstrike/podbot/podbot.dll");

   if (fp)
      fclose(fp);

   g_hBotLib = OpenLibrary(szBotDLLName);
   g_hGameLib = OpenLibrary("cstrike/dlls/mp.dll");
   

   if (strstr (szBotDLLName, "podbot"))
      g_bPODIngame = true;

   if (!g_hGameLib)
   {
      // try to extract the game DLL out of the Steam cache
      int size;
      unsigned char *filebuf = LOAD_FILE_FOR_ME("dlls/mp.dll", &size);

      if (filebuf)
      {
         #if defined (PF_WIN32)
            mkdir ("cstrike/dlls");
         #else
            mkdir ("cstrike/dlls", 0777);
         #endif

         fp = fopen("cstrike/dlls/mp.dll", "wb");
         if (fp)
         {
            // dump the file and close it
            fwrite(filebuf, size, 1, fp);
            fclose(fp);
         }
         FREE_FILE(filebuf);
      }
      g_hGameLib = OpenLibrary("cstrike/dlls/mp.dll");
   }

   assert (g_hGameLib && g_hBotLib);

   other_GetEntityAPI = (GETENTITYAPI)GetProcSymbol(g_hBotLib, "GetEntityAPI");
   other_GiveFnptrsToDll = (GIVEFNPTRSTODLL)GetProcSymbol(g_hBotLib, "GiveFnptrsToDll");
   
   pengfuncsFromEngine->pfnMessageBegin = pfnMessageBegin;
   pengfuncsFromEngine->pfnMessageEnd = pfnMessageEnd;
   pengfuncsFromEngine->pfnRegUserMsg = pfnRegUserMsg;
   pengfuncsFromEngine->pfnWriteByte = pfnWriteByte;
   pengfuncsFromEngine->pfnWriteShort = pfnWriteShort;
   pengfuncsFromEngine->pfnWriteChar = pfnWriteChar;
   pengfuncsFromEngine->pfnWriteString = pfnWriteString;
   pengfuncsFromEngine->pfnCreateFakeClient = pfnCreateFakeClient;
   pengfuncsFromEngine->pfnCmd_Args = pfnCmd_Args;
   pengfuncsFromEngine->pfnCmd_Argv = pfnCmd_Argv;
   pengfuncsFromEngine->pfnCmd_Argc = pfnCmd_Argc;
   pengfuncsFromEngine->pfnGetGameDir = pfnGetGameDir;
   pengfuncsFromEngine->pfnRunPlayerMove = pfnRunPlayerMove;
   pengfuncsFromEngine->pfnTraceLine = pfnTraceLine;
   pengfuncsFromEngine->pfnFindEntityByString = pfnFindEntByStr;

   g_hSelfLib = HandleFromMemPtr (&g_engfuncs); // get handle from memory pointer
   CombineExportTables (); // combine our and cs dll export tables

   (*other_GiveFnptrsToDll) (pengfuncsFromEngine, pGlobals);
   g_bot_engfuncs = pengfuncsFromEngine;
}

DLL_ENTRYPOINT
{
   if (DLL_DETACHING)
   {
      if (g_hBotLib)
         CloseLibrary (g_hBotLib);
      if (g_hGameLib)
         CloseLibrary (g_hGameLib);
   }
   DLL_RETENTRY;
}